#include <sys/stat.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <fstream>
#include <dirent.h>
#include <unistd.h>
#include <SDL/SDL.h>
#include <SDL/SDL_image.h>


SDL_Surface *IMG4,*IMG5,*IMG6,*IMG7,*IMG8,*IMG9,*IMG10,*IMG11,*IMG12;

char StartPath[PATH_MAX];



void UnLoadGraphics()
{
    SDL_FreeSurface(IMG4);
    SDL_FreeSurface(IMG5);
    SDL_FreeSurface(IMG6);
    SDL_FreeSurface(IMG7);
    SDL_FreeSurface(IMG8);
    SDL_FreeSurface(IMG9);
    SDL_FreeSurface(IMG10);
    SDL_FreeSurface(IMG11);
    SDL_FreeSurface(IMG12);
}

void LoadGraphics()
{
    char Filename[FILENAME_MAX+PATH_MAX];

    sprintf(Filename,"%scompare/4.png",StartPath);
    IMG4 = IMG_Load(Filename);

    sprintf(Filename,"%scompare/5.png",StartPath);
    IMG5 = IMG_Load(Filename);

    sprintf(Filename,"%scompare/6.png",StartPath);
    IMG6 = IMG_Load(Filename);

    sprintf(Filename,"%scompare/7.png",StartPath);
    IMG7 = IMG_Load(Filename);

    sprintf(Filename,"%scompare/8.png",StartPath);
    IMG8 = IMG_Load(Filename);

    sprintf(Filename,"%scompare/9.png",StartPath);
    IMG9 = IMG_Load(Filename);

    sprintf(Filename,"%scompare/10.png",StartPath);
    IMG10 = IMG_Load(Filename);

    sprintf(Filename,"%scompare/11.png",StartPath);
    IMG11 = IMG_Load(Filename);

    sprintf(Filename,"%scompare/12.png",StartPath);
    IMG12 = IMG_Load(Filename);
}

const int
        NrOfRows = 12,
        NrOfCols = 10,
        TileWidth = 16,
        TileHeight = 16,
        TileXOffset = 6,
        TileYOffset = 2,
        XOffset = 9,
        YOffset = 8;

void GetFilePath(char *InputFile,char *result)
{
    int Teller,Pos=0;
    for(Teller=strlen(InputFile)-1;Teller>=0;Teller--)
        if(InputFile[Teller] == '/' || InputFile[Teller] == '\\')
        {
            Pos = Teller+1;
            break;
        }
    memcpy(result,InputFile,Pos);
}

Uint32 SDL_GetPixel(SDL_Surface *surface, int x, int y)
{
    int bpp = surface->format->BytesPerPixel;
    /* Here p is the address to the pixel we want to retrieve */
    Uint8 *p = (Uint8 *)surface->pixels + y * surface->pitch + x * bpp;

    switch(bpp) {
    case 1:
        return *p;

    case 2:
        return *(Uint16 *)p;

    case 3:
        if(SDL_BYTEORDER == SDL_BIG_ENDIAN)
            return p[0] << 16 | p[1] << 8 | p[2];
        else
            return p[0] | p[1] << 8 | p[2] << 16;

    case 4:
        return *(Uint32 *)p;

    default:
        return 0;       /* shouldn't happen, but avoids warnings */
    }
}

bool Compare(SDL_Surface * Surface1,int X1,int Y1,SDL_Surface * Surface2,int X2,int Y2,int Width,int Height)
{
    int x,y;
    Uint8 R1,R2,G1,G2,B2,B1;
    Uint32 Pixel1,Pixel2;
    bool Result =true;
    SDL_LockSurface(Surface1);
    SDL_LockSurface(Surface2);


    for (x=0;x<Width;x++)
        for(y=0;y<Height;y++)
        {
            Pixel1 = SDL_GetPixel(Surface1,X1+x,Y1+y);
            Pixel2 = SDL_GetPixel(Surface2,X2+x,Y2+y);
            SDL_GetRGB(Pixel1,Surface1->format,&R1,&G1,&B1);
            SDL_GetRGB(Pixel2,Surface2->format,&R2,&G2,&B2);
            if( (R1!=R2) || (G1!=G2) || (B1 != B2) )
            {
                Result = false;
                break;
            }
        }
    SDL_UnlockSurface(Surface1);
    SDL_UnlockSurface(Surface2);
    return Result;

}

char chr(int ascii)
{
	return((char)ascii);
}

int main(int argc, char **argv)
{
    SDL_Surface *SDLScreen,*Tmp;
    char Path[PATH_MAX];
	srand((int) time(NULL));
	GetFilePath(argv[0],StartPath);
    FILE *f;
	struct dirent *Entry;
	DIR *Directory;
	struct stat Stats;
	int x,y,X,Y;
	Uint32 Pixel;
	Uint8 R,G,B;
	char Buffer[1];
	char FileName[PATH_MAX + FILENAME_MAX];
    sprintf(Path,"%slevels/",StartPath);
	if (SDL_Init(SDL_INIT_VIDEO | SDL_INIT_AUDIO ) == 0)
	{
        SDLScreen = SDL_SetVideoMode( 800 ,480,16, SDL_HWSURFACE );
		if(SDLScreen)
		{
            Directory = opendir(Path);
            if (Directory)
            {
                f=fopen("./levels.dat","wb");
                LoadGraphics();
                Entry=readdir(Directory);
                while(Entry)
                {
                    sprintf(FileName,"%s%s",Path,Entry->d_name);
                    stat(FileName,&Stats);

                    if(!S_ISDIR(Stats.st_mode))
                    {
                        //printf("%s\n",Entry->d_name);
                        if(strncmp(".", Entry->d_name, 1) && (strncmp("Thumbs.db",Entry->d_name,9)))
                        {
                             printf("%s\n%s\n",FileName,Entry->d_name);
                            Tmp = SDL_LoadBMP(FileName);
                            if(Compare(IMG4,0,0,Tmp,48,160,32,16))
                            {
                                Buffer[0] = chr(4);
                                fwrite(Buffer,1,1,f);
                            }
                            else
                            if(Compare(IMG5,0,0,Tmp,48,160,32,16))
                            {
                                Buffer[0] = chr(5);
                                fwrite(Buffer,1,1,f);
                            }
                            else
                            if(Compare(IMG6,0,0,Tmp,48,160,32,16))
                            {
                                Buffer[0] = chr(6);
                                fwrite(Buffer,1,1,f);
                            }
                            else
                            if(Compare(IMG7,0,0,Tmp,48,160,32,16))
                            {
                                Buffer[0] = chr(7);
                                fwrite(Buffer,1,1,f);
                            }
                            else
                            if(Compare(IMG8,0,0,Tmp,48,160,32,16))
                            {
                                Buffer[0] = chr(8);
                                fwrite(Buffer,1,1,f);
                            }
                            else
                            if(Compare(IMG9,0,0,Tmp,48,160,32,16))
                            {
                                Buffer[0] = chr(9);
                                fwrite(Buffer,1,1,f);
                            }
                            else
                            if(Compare(IMG10,0,0,Tmp,48,160,32,16))
                            {
                                Buffer[0] = chr(10);
                                fwrite(Buffer,1,1,f);
                            }
                            else
                            if(Compare(IMG11,0,0,Tmp,48,160,32,16))
                            {
                                Buffer[0] = chr(11);
                                fwrite(Buffer,1,1,f);
                            }
                            else
                            if(Compare(IMG12,0,0,Tmp,48,160,32,16))
                            {
                                Buffer[0] = chr(12);
                                fwrite(Buffer,1,1,f);
                            }
                            else
                            {
                                Buffer[0] = chr(255);
                                fwrite(Buffer,1,1,f);
                            }

                            SDL_LockSurface(Tmp);
                            for(y=0;y<NrOfRows;y++)
                                for(x=0;x<NrOfCols;x++)
                                {
                                    X = (((x+TileXOffset) * TileWidth )+XOffset);
                                    Y = (((y+TileYOffset) * TileHeight )+YOffset);
                                    Pixel = SDL_GetPixel(Tmp,X,Y);
                                    SDL_GetRGB(Pixel,Tmp->format,&R,&G,&B);
                                    if((R==255) && (G==255) && (B==255))
                                    {
                                        Buffer[0] = chr(5);
                                        fwrite(Buffer,1,1,f);
                                    }
                                    else
                                    if((R==127) && (G==127) && (B==127))
                                    {
                                            Buffer[0] = chr(4);
                                            fwrite(Buffer,1,1,f);
                                    }
                                    else

                                    if((R==64) && (G==96) && (B==248))
                                    {
                                            Buffer[0] = chr(3);
                                            fwrite(Buffer,1,1,f);
                                    }
                                    else
                                    if((R==72) && (G==160) && (B==104))
                                    {
                                            Buffer[0] = chr(2);
                                            fwrite(Buffer,1,1,f);
                                    }
                                    else
                                    if((R==216) && (G==64) && (B==96))
                                    {
                                            Buffer[0] = chr(1);
                                            fwrite(Buffer,1,1,f);

                                    }
                                    else
                                    {
                                        Buffer[0] = chr(0);
                                        fwrite(Buffer,1,1,f);
                                    }

                                }
                            SDL_UnlockSurface(Tmp);
                            SDL_BlitSurface(Tmp,NULL,SDLScreen,NULL);
                            SDL_Flip(SDLScreen);
                            SDL_FreeSurface(Tmp);
                        }
                    }
                    Entry=readdir(Directory);
                }
                closedir(Directory);
                fclose(f);
                UnLoadGraphics();
            }
            SDL_FreeSurface(SDLScreen);
		}
		else
		{
			printf("Failed to Set Videomode %dx%dx16\n",800, 480);
		}
		SDL_Quit();
	}
	else
	{
		printf("Couldn't initialise SDL!\n");
	}
	//since the destructor isn't being called clean up the stuff ourselves
	//muntrace();
	//chdir("/usr/gp2x");
	//execl("/usr/gp2x/gp2xmenu", "/usr/gp2x/gp2xmenu", NULL);

	return 0;

}
