#include "CEffects.h"


CEffects::CEffects(SDL_Surface *Source,int X,int Y,int Width,int Height)
{
    SDL_Surface *Tmp;
    Tmp = SDL_CreateRGBSurface(SDL_SWSURFACE,Source->w,Source->h,Source->format->BitsPerPixel,Source->format->Rmask,Source->format->Gmask,Source->format->Bmask,Source->format->Amask);
    CurrentImage = SDL_DisplayFormat(Tmp);
    SDL_FreeSurface(Tmp);
    SDL_BlitSurface(Source,NULL,CurrentImage,NULL);
    SDL_SetColorKey(CurrentImage,SDL_SRCCOLORKEY,SDL_MapRGB(CurrentImage->format,255,0,255));
    StartX = X;
    StartY = Y;
    EndX = StartX + Width;
    EndY = StartY + Height;
    Done = true;
  //  TotalSecs = 0;

}

void CEffects::DoAlpha()
{
    if(Steps < MaxSteps)
    {
        AlphaValue-=AlphaInc;
        if (AlphaValue < 0)
        {
            AlphaValue = 0;
            Steps = MaxSteps;
        }
        SDL_SetAlpha(CurrentImage,SDL_SRCALPHA,AlphaValue);
        Steps++;
    }
    else
    if(!Done)
    {
        CurrentEffect = EfNone;
        Done = true;
        SDL_FillRect(CurrentImage,NULL,SDL_MapRGB(CurrentImage->format,255,0,255));
    }
}

void CEffects::Alpha(int aMaxSteps,int aAlphaInc)
{
    AlphaValue = 255;
    Steps = 0;
    MaxSteps = aMaxSteps;
    AlphaInc = aAlphaInc;
    CurrentEffect = EfAlpha;
    Done = false;
}

void CEffects::BlockRemove(int aMaxSteps,int aNrOfBlocks,int aWidth, int aHeight)
{
    Steps = 0;
    MaxSteps = aMaxSteps;
    BlockWidth = aWidth;
    BlockHeight = aHeight;
    NrOfBlocks = aNrOfBlocks;
    CurrentEffect = EfBlockRemove;
    Done = false;

}

void CEffects::DoBlockRemove()
{
    int Teller,X,Y;
    SDL_Rect Dst;
    if(Steps < MaxSteps)
    {
        Teller=0;

        while(Teller<NrOfBlocks)
        {
            X = rand() %(EndX - StartX);
            Y = rand() %(EndY - StartY);
            Dst.x = X+StartX;
            Dst.y = Y+StartY;
            Dst.w = BlockWidth;
            Dst.h = BlockHeight;
            SDL_FillRect(CurrentImage,&Dst,SDL_MapRGB(CurrentImage->format,255,0,255));
            Teller++;
        }

        Steps++;
    }
    else
    if(!Done)
    {
        CurrentEffect = EfNone;
        Done = true;
        SDL_FillRect(CurrentImage,NULL,SDL_MapRGB(CurrentImage->format,255,0,255));
    }
}

void CEffects::VerticalLine(int aMaxSteps,int aNrOfLines,int aWidth)
{
    Steps = 0;
    BlockWidth = aWidth;
    MaxSteps = aMaxSteps;
    NrOfLines = aNrOfLines;
    CurrentEffect = EfVerticalLine;
    Done = false;

}

void CEffects::DoVerticalLine()
{
    int Teller,X;
    SDL_Rect Dst;
    if(Steps < MaxSteps)
    {
        Teller=0;
        while(Teller<NrOfLines)
        {
            X = rand() % (EndX-StartX);
            Dst.x = X+StartX;
            Dst.y = StartY;
            Dst.w = BlockWidth;
            Dst.h = (EndY-StartY);
            SDL_FillRect(CurrentImage,&Dst,SDL_MapRGB(CurrentImage->format,255,0,255));
            Teller++;
        }
        Steps++;
    }
    else
    if(!Done)
    {
        CurrentEffect = EfNone;
        Done = true;
        SDL_FillRect(CurrentImage,NULL,SDL_MapRGB(CurrentImage->format,255,0,255));
    }
}

void CEffects::HorizontalLine(int aMaxSteps,int aNrOfLines,int aHeight)
{
    Steps = 0;
    BlockHeight = aHeight;
    MaxSteps = aMaxSteps;
    NrOfLines = aNrOfLines;
    CurrentEffect = EfHorizontalLine;
    Done = false;

}

void CEffects::DoHorizontalLine()
{
    int Teller,Y;
    SDL_Rect Dst;
    if(Steps < MaxSteps)
    {
        Teller=0;
        while(Teller<NrOfLines)
        {
            Y = rand() % (EndY-StartY);
            Dst.x = StartX;
            Dst.y = Y+StartY;
            Dst.w = (EndX-StartX);
            Dst.h = BlockHeight;
            SDL_FillRect(CurrentImage,&Dst,SDL_MapRGB(CurrentImage->format,255,0,255));
            Teller++;
        }
        Steps++;
    }
    else
    if(!Done)
    {
        CurrentEffect = EfNone;
        Done = true;
        SDL_FillRect(CurrentImage,NULL,SDL_MapRGB(CurrentImage->format,255,0,255));
    }
}

void CEffects::PixelRemove(int aMaxSteps,int AmountOfPixelsPerStep)
{

    Steps = 0;
    MaxSteps = aMaxSteps;
    PixelRemoveNumPixels = AmountOfPixelsPerStep;
    CurrentEffect = EfPixelRemove;
    Done = false;

}

void CEffects::DoPixelRemove()
{
    int Teller,X,Y;
    if(Steps < MaxSteps)
    {
        Teller=0;
        SDL_LockSurface(CurrentImage);
        while(Teller<PixelRemoveNumPixels)
        {
            X = rand() % (EndX-StartX);
            Y = rand() % (EndY-StartY);
            SDL_PutPixel(CurrentImage,X+StartX,Y+StartY,SDL_MapRGB(CurrentImage->format,255,0,255));
            Teller++;
        }
        SDL_UnlockSurface(CurrentImage);
        Steps++;
    }
    else
    if(!Done)
    {
        CurrentEffect = EfNone;
        Done = true;
        SDL_FillRect(CurrentImage,NULL,SDL_MapRGB(CurrentImage->format,255,0,255));
    }

}

void CEffects::DoEffect()
{
   // Uint32 Time1;
   // float Secs;
    switch (CurrentEffect)
    {
        case EfPixelRemove :
           // Time1 = SDL_GetTicks();
            DoPixelRemove();
            //Secs = ((float)SDL_GetTicks()-(float)Time1)/1000;
            //TotalSecs+=Secs;
            //printf("EfPixelRemove %d %d, secs :%f Total Secs :%f\n",MaxSteps,PixelRemoveNumPixels,Secs,TotalSecs);
            break;

        case EfHorizontalLine :
            //Time1 = SDL_GetTicks();
            DoHorizontalLine();
            //Secs = ((float)SDL_GetTicks()-(float)Time1)/1000;
            //TotalSecs+=Secs;
           // printf("EfHorizontalLine %d %d, secs :%f Total Secs :%f\n",MaxSteps,NrOfLines ,Secs,TotalSecs);
            break;

        case EfVerticalLine :
           // Time1 = SDL_GetTicks();
            DoVerticalLine();
           // Secs = ((float)SDL_GetTicks()-(float)Time1)/1000;
           // TotalSecs+=Secs;
           // printf("EfVerticalLine %d %d, secs :%f Total Secs :%f\n",MaxSteps,NrOfLines,Secs,TotalSecs);
            break;

        case EfBlockRemove:
           // Time1 = SDL_GetTicks();
            DoBlockRemove();
            //Secs = ((float)SDL_GetTicks()-(float)Time1)/1000;
           // TotalSecs+=Secs;
           // printf("EfBlockRemove %d %d, secs :%f Total Secs :%f\n",MaxSteps,NrOfBlocks,Secs,TotalSecs);
            break;

        case EfAlpha:
           // Time1 = SDL_GetTicks();
            DoAlpha();
            //Secs = ((float)SDL_GetTicks()-(float)Time1)/1000;
            //TotalSecs+=Secs;
           // printf("EfAlpha %d %d, secs :%f Total Secs :%f\n",MaxSteps,AlphaInc,Secs,TotalSecs);
            break;

        default :
            break;
    }
}

void CEffects::Draw(SDL_Surface *Dest)
{
    if(!Done)
        SDL_BlitSurface(CurrentImage,NULL,Dest,NULL);
}

CEffects::~CEffects()
{
    SDL_FreeSurface(CurrentImage);
}
